// SamoposlugaT.java - Ispitivanje rada samoposluge.

import samoposluga.Samoposluga;
import usluge.*;
import java.awt.*;
import java.awt.event.*;

public class SamoposlugaT extends Frame {

  private static int ukBroj;
  private Samoposluga samoposl;
  private SamoposlugaT prozor = this;
  private Button dgmOtvori  = new Button ("Otvori"),
                 dgmZatvori = new Button ("Zatvori"),
                 dgmUnisti  = new Button ("Unisti");
  
  private SamoposlugaT (String[] vpar) {
    super ("Samoposluga " + ++ukBroj);
    setBounds (50, 50, 500, 200);
    setLayout (new BorderLayout ());
    addWindowListener (new ProzorDogadjaj ());
    // Ploca za komandnu dugmad.
    Panel ploKomande = new Panel();
    add (ploKomande, "North");
    ploKomande.setLayout (new FlowLayout ());
    ploKomande.setBackground (new Color(255, 192, 192));
    ploKomande.add (dgmOtvori );
    ploKomande.add (dgmZatvori);
    ploKomande.add (dgmUnisti );
    DugmeAkcija akcija = new DugmeAkcija ();
    dgmOtvori .addActionListener (akcija);
    dgmZatvori.addActionListener (akcija);
    dgmUnisti .addActionListener (akcija);
    // Ploca za prikaz ulaza.
    Panel ploUlazi = new Panel ();
    add (ploUlazi, "West");
    ploUlazi.setBackground (new Color(192, 255, 192));
    // Ploce za prikaz kasa i redova.
    Panel ploca = new Panel ();
    add (ploca, "Center");
    ploca.setLayout (new BorderLayout ());
    Panel ploKase = new Panel ();
    Panel ploRedovi = new Panel ();
    ploca.add (ploKase, "North");
    ploca.add (ploRedovi, "Center");
    ploKase.setBackground (new Color(192, 192, 255));
    ploRedovi.setBackground (new Color(192, 192, 192));
    int brUlaza = Integer.parseInt (vpar[1]),
        brKasa  = Integer.parseInt (vpar[2]);
    // Polja za razne delove samoposluge.    
    try {
      Label oznKupci = new Label ();
      ploKomande.add (oznKupci);
      Polje pKupci = new Polje (oznKupci);
      // Polja za ulaze
      ploUlazi.setLayout (new GridLayout (brUlaza, 1));
      Polje[] pUlazi  = new Polje [brUlaza];
      for (int i=0; i<brUlaza; i++) {
        Label oznaka = new Label ();
        ploUlazi.add (oznaka);
        pUlazi[i] = new Polje(oznaka);
      }
      // Polja za kase i za redove
      ploKase  .setLayout (new GridLayout (1, brKasa));
      ploRedovi.setLayout (new GridLayout (1, brKasa));
      Polje[] pKase   = new Polje [brKasa];
      Polje[] pRedovi = new Polje [brKasa];
      for (int i=0; i<brKasa; i++) {
        Label oznaka = new Label ();
        ploKase.add (oznaka);
        pKase[i]   = new Polje (oznaka);
        TextArea tekst = new TextArea ();
        ploRedovi.add (tekst);
        pRedovi[i] = new Polje (tekst);
      }
      // Stvaranje samoposluge.
      samoposl = new Samoposluga (
        brUlaza, brKasa,
        Integer.parseInt (vpar[3]), // maxUlaz
        Integer.parseInt (vpar[4]), // maxKupovina
        Integer.parseInt (vpar[5]), // maxNaplata
        pKupci, pUlazi, pKase, pRedovi
      );
    } catch (GPoljeNeOdgovara g) { new NeocekivanaGreska (); }
  } // SamoposlugaT()
  
  class DugmeAkcija implements ActionListener {
    public void actionPerformed (ActionEvent d) {
      Component k = (Component)d.getSource ();
      if (k == dgmOtvori ) samoposl.otvori  ();
      if (k == dgmZatvori) samoposl.zatvori ();
      if (k == dgmUnisti ) { 
        samoposl.unisti  (); prozor.dispose ();
      }
    }
  } // class DugmeAkcija
  
  class ProzorDogadjaj extends WindowAdapter {
    public void windowClosing (WindowEvent d) {
      samoposl.unisti ();
      dispose ();
    }
    public void windowClosed (WindowEvent d) {
      if (--ukBroj == 0) System.exit (0);
    }
  } // class ProzorDogadjaj

  public static void main (String[] vpar) {
    for (int i=0; i<Integer.parseInt (vpar[0]); i++)
      new SamoposlugaT (vpar).show ();
  }
} // class SamoposlugaT
