// Red.java - Red za cekanje kupaca.

package samoposluga;
import usluge.Polje;

class Red {

  private static class Elem {
    Kupac kupac; Elem  sled;
    Elem (Kupac k) { this.kupac = k; }
    Elem (Kupac k, Elem s) { kupac = k; sled  = s; }
  } // class Elem

  private volatile Elem prvi, posl;
  private Polje polje;
  
  Red (Polje p) { polje = p; }

  synchronized void stavi (Kupac kupac) {
    Elem novi = new Elem (kupac);
    if (prvi == null) prvi      = novi;
      else            posl.sled = novi;
    posl = novi;
    notifyAll ();
    if (polje != null) polje.pisi (toString ());
  }

  synchronized Kupac uzmi () throws InterruptedException {
    while (prvi == null) wait ();
    Kupac kupac = prvi.kupac;
    prvi = prvi.sled; if (prvi == null) posl = null;
    if (polje != null) polje.pisi (toString());
    return kupac;
  }
  
  public synchronized String toString () {
    StringBuffer s = new StringBuffer ();
    for (Elem tek=prvi; tek!=null; tek=tek.sled)
      s.append(tek.kupac.id()).append('\n');
    return s.toString ();
  }

} // class Red
