// Ulaz.java - Ulaz u samoposlugu.

package samoposluga;

import usluge.Polje;
import java.awt.Color;
class Ulaz extends Thread {

  private static int ukId = 0;
  private int maxUlaz, maxKupovina, id=++ukId;
  private Samoposluga samoposl;
  private Polje polje;
  private boolean gotovo=false, radi=false;

  Ulaz (Samoposluga samop, int maxUl, int maxKup,
        Polje p) {
    samoposl = samop;
    maxUlaz = maxUl;
    maxKupovina = maxKup;
    if ((polje = p) != null) {
      polje.komponenta().setForeground (Color.red);
      polje.pisi ("Ulaz" + id + "     ");
    }
    start ();
  }

  public void run () {
    while (! gotovo) {
      if (! radi) synchronized (this) { 
        while (! radi)
          try { wait (); } catch (InterruptedException e) {} 
      }
    if (gotovo) break;
      try { sleep ((long) (Math.random() * maxUlaz));
        samoposl.usaoKupac ();
        Kupac kupac = new Kupac (samoposl, maxKupovina);
        if (polje != null) polje.pisi ("Ulaz" + id +": " + kupac.id());
      } catch (InterruptedException e) {}
    }
  }

  synchronized void zatvori () {      // Umesto suspend()
    radi = false;
    interrupt ();
    if (polje != null) {
      polje.pisi ("Ulaz" + id);
      polje.komponenta().setForeground (Color.red);
    }
  }

  synchronized void otvori () {       // Umesto resume()
    if (! radi) { radi = true; notify (); }
    if (polje != null) polje.komponenta().setForeground (Color.black);
  }

  synchronized void zavrsi () {       // Umesto stop()
    gotovo = true; interrupt (); 
    if (! radi) { radi = true; notify (); }
  }

  int id () { return id; }

} // class Ulaz
