// Skladiste.java - Klasa za uskladistavanje podataka.

package skladista;
import usluge.Polje; // Veza sa grafickom povrsom.

public class Skladiste {

  private static volatile int ukId = 0;
  private volatile int[] niz;
  private volatile int ulaz, izlaz, pun, id=++ukId;
  private volatile Polje polje;

  public Skladiste (int kap, Polje p) { 
    if ((niz = new int [kap]) == null) System.exit (1);
    polje = p;
  }
  public Skladiste (int kap) { this (kap, null); } 
  public synchronized void stavi (int vredn) {
    while (pun == niz.length)
      try { wait (); } 
        catch (InterruptedException g) {}
    niz[ulaz++] = vredn; if (ulaz == niz.length) ulaz = 0;
    pun++;
    notifyAll ();
    if (polje != null) polje.pisi (toString());
  }
  public synchronized int uzmi () {
    while (pun == 0)
      try { wait (); } catch (InterruptedException g) {}
    int vredn = niz[izlaz++]; if (izlaz == niz.length) izlaz = 0;
    pun--;
    notifyAll ();
    if (polje != null) polje.pisi (toString());
    return vredn;
  }
  public int id     () { return id; }
  public int puno   () { return pun; }
  public int prazno () { return niz.length - pun; }
  public synchronized String toString () {
    StringBuffer s = new StringBuffer ();
    for (int i=0; i<pun; i++)
      s.append(niz[(izlaz+i)%niz.length]).append('\n');
    return s.toString();
  }
} // class Skladiste