// CrtezIterator.java - Spoljasnji Iterator koji moze da 
//                      obilazi figure u Crtezu u dva smera.

package figure;

public class CrtezIterator implements Iterator {

  private int tek;
  
  private Figura fig;
   
  public CrtezIterator(Figura fig) 
    { this.fig = fig; tek = -1; }
   
  public void naPrvi() { tek = 0; }
  
  public void naZadnji() { tek = fig.brojFigura()-1; }
   
  public boolean gotovo() 
    { return tek<0 || tek>=fig.brojFigura(); }

  public Figura tekuci() throws GNemaTekuceg {
    if (gotovo()) throw new GNemaTekuceg();
    try { return fig.dohvati(tek); } 
      catch (GNijeCrtez g) { throw new GNemaTekuceg(); }
      catch (GIndeks g) {}
    return null;
  }
   
  public void sledeci() { tek++; }
  
  public void prethodni() { tek--; }

} // class CrtezIterator