// Trougao.java - Prosta Figura za trouglove u ravni.

package figure;

public class Trougao extends Figura {

  private Tacka A;
  private Tacka B;
  private Tacka C;
   
  public Trougao(Boja boja, Tacka A, Tacka B, Tacka C) 
    { super(boja); this.A = A; this.B = B; this.C = C; }
  
  public Trougao (Tacka A, Tacka B, Tacka C)
    { this (new Boja(), A, B, C); }
  
  public Trougao(Boja boja) 
    { this (boja, new Tacka(-1,-1), new Tacka(1,-1), new Tacka(0,1)); }
  
  public Trougao() {
    this (new Boja(), new Tacka(-1,-1),
          new Tacka(1,-1), new Tacka(0,1));
  }
  
  public Tacka A() { return A; }
  
  public Tacka B() { return B; }
  
  public Tacka C() { return C; }
  
  public Figura kopija() {
    return new Trougao (boja.kopija(), A.kopija(), B.kopija(), C.kopija());
  }
  
  public boolean pripada(Tacka T) {
    return Math.abs (
             new Trougao(A,B,T).P() +
             new Trougao(B,C,T).P() +
             new Trougao(C,A,T).P() - P()
           ) <= 1e-6;
  }
   
  public double P() {
    double a = B.d(C), b = C.d(A), c = A.d(B);
    double s = (a + b + c) / 2;
    return Math.sqrt(s*(s-a)*(s-b)*(s-c));
  }

} // class Trougao